// player.cc
// Ian Lance Taylor for ICFP 2002

#include <cstdlib>
#include <string>
#include <iostream>

#include "debug.h"
#include "socket.h"
#include "player.h"

void
Player::read(
  Socket& sock)
{
  std::string s = sock.getline();
  char* end;

  this->m_id = strtol(s.c_str(), &end, 10);
  if (*end != ' ')
    {
      std::clog << "syntax error in player configuration: " << s << std::endl;
      exit(1);
    }

  this->m_carry = strtol(end, &end, 10);
  if (*end != ' ')
    {
      std::clog << "syntax error in player configuration: " << s << std::endl;
      exit(1);
    }

  this->m_money = strtol(end, 0, 10);
}

void
Player::bumped(
  bool yes)
{
  this->m_bumped <<= 1;
  if (yes)
    {
      this->m_bumped |= 1;
      if (debug_flag)
	{ std::cout << "Bumped!" << std::endl; }
    }
}

int
Player::bumped_count()
{
  int ret = 0;
  for (int i = 0; i < 10; ++i)
    {
      if ((this->m_bumped & (1U << i)) != 0)
	{ ++ret; }
    }
  return ret;
}

std::ostream&
operator<<(
  std::ostream& os,
  const Player& p)
{
  os << p.m_id << ' ' << p.m_carry << ' ' << p.m_money << std::endl;
  return os;
}
